<?php


namespace Drupal\travolute\ValueObject;
use \JsonSerializable;

class Booking implements JsonSerializable {

  private $id;
  private $code;
  private $externalCode;
  private $agent;
  private $departureDate;
  private $accommodationName;
  private $travelAgentName;
  private $created_at;
  private $updated_at;
  private $accommodationId;
  private $numberOfDays;
  private $roomTypeId;
  private $boardTypeId;
  private $occupancy;
  private $departureAirportId;
  private $customers;
  private $priceModel;
  private $priceAvailabilityModel;

  public function __construct($newBooking) {
    if (property_exists($newBooking, 'id')) {
      $this->id = $newBooking->id;
    }
    if (property_exists($newBooking, 'externalCode')) {
      $this->externalCode = $newBooking->externalCode;
    }
    if (property_exists($newBooking, 'agent')) {
      $this->agent = $newBooking->agent;
    }
    if (property_exists($newBooking, 'departureDate')) {
      $this->departureDate = $newBooking->departureDate;
    }
    if (property_exists($newBooking, 'accommodationName')) {
      $this->accommodationName = $newBooking->accommodationName;
    }
    if (property_exists($newBooking, 'travelAgentName')) {
      $this->travelAgentName = $newBooking->travelAgentName;
    }
    if (property_exists($newBooking, 'created_at')) {
      $this->created_at = $newBooking->created_at;
    }
    if (property_exists($newBooking, 'updated_at')) {
      $this->updated_at = $newBooking->updated_at;
    }
    if (property_exists($newBooking, 'code')) {
      $this->code = $newBooking->code;
    }
    if (property_exists($newBooking, 'accommodationId')) {
      $this->accommodationId = $newBooking->accommodationId;
    }
    if (property_exists($newBooking, 'numberOfDays')) {
      $this->numberOfDays = $newBooking->numberOfDays;
    }
    if (property_exists($newBooking, 'roomTypeId')) {
      $this->roomTypeId = $newBooking->roomTypeId;
    }
    if (property_exists($newBooking, 'boardTypeId')) {
      $this->boardTypeId = $newBooking->boardTypeId;
    }
    if (property_exists($newBooking, 'occupancy')) {
      $this->occupancy = $newBooking->occupancy;
    }
    if (property_exists($newBooking, 'departureAirportId')) {
      $this->departureAirportId = $newBooking->departureAirportId;
    }
    if (property_exists($newBooking, 'customers')) {
      $this->customers = $newBooking->customers;
    }
    if (property_exists($newBooking, 'priceModel')) {
      $this->priceModel = $newBooking->priceModel;
    }
    if (property_exists($newBooking, 'priceAvailabilityModel')) {
      $this->priceAvailabilityModel = $newBooking->priceAvailabilityModel;
    }
  }

  public function jsonSerialize(): array {
    return  [
      'id' => $this->id,
      'externalCode' => $this->externalCode,
    ];
  }

}
